// flips bit n in a file
// usage: flip_bit <bit> <infile> <outfile>

// now flips the i'th bit and also i+14 and i+15, in accordance with ajmartin's post at
// http://forum.nasaspaceflight.com/index.php?topic=34597.msg1201383#msg1201383

// won't work for frames larger than a megabyte

#include <iostream>
#include <ostream>
#include <fstream>

#include <boost/lexical_cast.hpp>

int main(int argc, char * argv[]) {
	if (argc < 4)
		exit(1);

	// read
	std::ifstream infile(argv[2]);

	const int bufsize = 1048576;
	char buf[bufsize];

	infile.read(&buf[0], bufsize);

	// flip
	int bit_num = boost::lexical_cast<int>(argv[1]);
	int byte_num = bit_num / 8;
	int subbit = 7 - (bit_num % 8);
	buf[byte_num] = buf[byte_num] ^ (1 << subbit);
/*
	if (bit_num + 15 < infile.gcount() * 8) {
		bit_num += 14;
		byte_num = bit_num / 8;
		subbit = 7 - (bit_num % 8);
		buf[byte_num] = buf[byte_num] ^ (1 << subbit);
		++bit_num;
		byte_num = bit_num / 8;
		subbit = 7 - (bit_num % 8);
		buf[byte_num] = buf[byte_num] ^ (1 << subbit);
	}
*/
	// write
	std::ofstream outfile(argv[3]);

	outfile.write(&buf[0], infile.gcount());

	return 0;
}

